<template>
  <div class="demo-layout mdl-layout mdl-js-layout mdl-layout--fixed-header">
    <Header />
    <main class="mdl-layout__content mdl-color--grey-100">
      <div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-tablet mdl-grid">
        <!-- Container for the Table of content -->
        <div
          class="mdl-card mdl-shadow--2dp mdl-cell mdl-cell--12-col mdl-cell--12-col-tablet mdl-cell--12-col-desktop"
        >
          <div class="mdl-card__supporting-text mdl-color-text--grey-600">
            <!-- div to display the generated Instance ID token -->
            <div id="token_div" :style="[showToken ? {display: 'block'}: {display: 'none'}]">
              <h4>Instance ID Token</h4>
              <p style="word-break: break-all;">{{token}}</p>
              <button
                class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored"
                v-on:click="deleteToken(vm)"
              >Delete Token</button>
            </div>
            <!-- div to display the UI to allow the request for permission to
               notify the user. This is shown if the app has not yet been
            granted permission to notify.-->
            <div :style="[req_permission ? {display: 'block'}: {display: 'none'}]">
              <h4>Needs Permission</h4>
              <p>{{token}}</p>
              <button
                class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored"
                v-on:click="requestPermission()"
              >Request Permission</button>
            </div>
            <!-- div to display messages received by this app. -->
            <div id="messages"></div>
          </div>
        </div>
      </div>
    </main>
  </div>
</template>

<script>
import Header from './Header'
import {mapGetters, mapActions, mapMutations} from 'vuex';
import * as types from '../store/types';
export default {
  name: 'FirebaseFCM',
  components: {
    Header
  },
  data: function() {
    return {
      vm: { vm: this }
    }
  },
  computed: {
      ...mapGetters({
        req_permission: types.REQ_PERMISSION,
        token: types.GET_TOKEN,
        showToken: types.SHOW_TOKEN
      })
  },
  methods: {
    ...mapActions({
      deleteToken: types.MUTATE_DELETE_TOKEN
    }),
    ...mapMutations({
      requestPermission: types.MUTATE_REQ_PERMISSION
    })
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
